<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Rating extends Controller_Handler
{
    /** @var  Model_Rating */
    protected $model;
    
    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_TEACHER);
        $this->model = new Model_Rating;
    }

    public function action_SetRate()
    {
		$data['success'] = false;
        $this->post -> rule('studentID', 'not_empty')
                    -> rule('studentID', 'digit')
                    -> rule('submoduleID', 'not_empty')
                    -> rule('submoduleID', 'digit')
                    -> rule('rate', 'digit')
                    -> rule('rate', 'range', array(':value', -1, 100));
        if($this->post->check()) {
            $result = Model_Rating::SetStudentRate( $this->user->TeacherID,
                                                    $this->post['studentID'],
                                                    $this->post['submoduleID'],
                                                    $this->post['rate']);
			$data['success'] = ($result[0]['Num'] == 0);
        }
        $this->response->body(json_encode($data));
    }

    public function action_SelectGroup(){
        $data['success'] = false;
        $this->post -> rule('disciplineID', 'digit')
                    -> rule('disciplineID', 'not_empty')
                    -> rule('groupSelected', 'digit')
                    -> rule('groupSelected', 'not_empty');
        if($this->post->check()) {
            //$SGID = Cookie::get('SGID', null);
            $SG_json = json_decode(Cookie::get('SGID', null), true);
            
            $SG_json[$this->post['disciplineID']] = $this->post['groupSelected'];

            Cookie::set('SGID', json_encode($SG_json), '2592000'); 
            $data['success'] = true;
        }
        $this->response->body(json_encode($data));
    }

    public function action_SetExamPeriodOption() {
        $data['success'] = false;
        $this->post -> rule('studentID', 'not_empty')
            -> rule('studentID', 'digit')
            -> rule('submoduleID', 'not_empty')
            -> rule('submoduleID', 'digit');

        if($this->post->check()) {
            // option check
            $parametersCheckPassed = true;
            switch ($this->post['option']) {
                case 'null' :
                case 'absence':
                case 'pass':
                    break;
                default:
                    $parametersCheckPassed = false;
            }
            if ($parametersCheckPassed) {
                $res = Model_Rating::setExamPeriodOption($this->post['studentID'], $this->post['submoduleID'], $this->post['option']);
                if ($res['ErrorCode'] == 0)
                    $data['success'] = true;
            }
        }
        $this->response->body(json_encode($data));
    }
}